#include "OctoWS2811hubbe.h"

// maximum
const unsigned int ledsPerStrip = 1024;

DMAMEM int displayMemory[ledsPerStrip*6];
int drawingMemory[ledsPerStrip*6];

const int config = WS2811_800kHz; // color config is on the PC side

OctoWS2811hubbe leds(ledsPerStrip, displayMemory, drawingMemory, config);

void setup() {
  leds.begin();
  leds.show();
  pinMode(13, OUTPUT);
}

void loop() {
  // Sync character
  switch (Serial.read()) {
    default:
      return;

   case 0xED: // Sync
      leds.busy();
      Serial.write(Serial.read());
      break;

   case 0xEE: // update lights
     digitalWrite(13, HIGH);
     unsigned int num_leds = Serial.read() << 8;
     num_leds |= Serial.read();
     unsigned int to_read = min(num_leds * 3 * 8, sizeof(displayMemory));
     unsigned int count = Serial.readBytes((char *)drawingMemory, to_read);
     digitalWrite(13, LOW);
     if (count != to_read) return;
     while (num_leds > ledsPerStrip) {
       char tmp[24];
       Serial.readBytes(tmp, sizeof(tmp));
       num_leds--;
     }
     
     leds.setLen(num_leds);
     leds.show();
  }
}

