#include <stdio.h>
#include <termios.h>
#include "lightbuffer.h"
#include "random.h"
#include "timing.h"

#define CMD "ssh 10.0.5.11 wget -O/home/hubbe/hack/teensy/chaosdisplay/software/images/light_%d.jpg http://10.0.5.150:8080/shot.jpg"
// #define CMD "wget -O/home/hubbe/hack/teensy/chaosdisplay/software/images/light_%d.jpg http://10.0.5.151:8080/shot.jpg"

void AcquireImage(int image) {
  char tmp[256];
  sprintf(tmp, CMD, image);
  while (system(tmp));
}

int main(int argc, char **argv) {
  int images = atoi(argv[1]);
  // In theory, we need at least log2(lights/LIGHT_BATCHES)*LIGHT_BATCHES images.
  // In practice, we probably want quite a lot more.
  // Probably esier to acquire more images than you need and then
  // only use them if you required than to go back and acquire more
  // images later, so I would probably start with 300 images, which
  // is probably 5 times what you actually need.
  LightBuffer* lb = GetLightBuffer();
  std::vector<int> geometry;
  lb->GetGeometry(&geometry);

  for (int s = 0; s < geometry.size(); s++) {
    for (int l = 0; l < geometry[s]; l++){
      lb->Set(s, l, Color(0,0,0));
    }
  }
  lb->Show();
  lb->Show();
  lb->Show();

  for (int i = 0; i < images; i++) {
    for (int s = 0; s < geometry.size(); s++) {
      for (int l = 0; l < geometry[s]; l++){
	unsigned char level = NotRandom::RandomOn(i, s, l) ? 0xFF : 0;
	lb->Set(s, l, Color(level, level, level));
      }
    }
    lb->Show();
    lb->Sync();
    // Wait for camera to adjust on first image, delay
    // for sanity on the rest of the images.
    Sleep(i == 0 ? 5.0 : 0.3);
    AcquireImage(i);

    // Reset all pixels to black.
    for (int s = 0; s < geometry.size(); s++)
      for (int l = 0; l < geometry[s]; l++)
	lb->Set(s, l, Color());
  }

  // Set it back to black
  lb->Show();
}
