#include <stdio.h>
#include "lightbuffer.h"
#include "math.h"
#include "timing.h"
#include <stdlib.h>

void Update(int* tmp, int n) {
  tmp[0] = tmp[n];
  tmp[n+1] = tmp[1];
  int a;
  int b = tmp[0];
  int c = tmp[1];
  for (int i = 1; i <= n; i++) {
    a = b; b = c; c = tmp[i+1];
    int x = (a + b * 55 + c * 8 - 3100) >> 6;
    if (x > 60000 && (x % 17) == 0) x += 17 * 256 + 1;
    if (x > 65536) x = 65536;
    if (x < 0) x += 65536;
    if ((x % 3997) == 0) x = 65536 - x;
    tmp[i] = x;
  }
}

int main(int argc, char **argv) {
  LightBuffer* l = GetLightBuffer();
  std::vector<int> geometry;
  l->GetGeometry(&geometry);

  double z = 0.0;
  int frame = 0;
  int cells = 0;
  struct timeval t = Time();
  for (int i = 0; i < geometry.size(); i++) {
    for (int lamp = 0; lamp < geometry[i]; lamp++) {
      l->Set(i, lamp, Color(0,0,0));
      cells++;
    }
  }
  l->Show();
  l->Show();
  l->Show();

  int r[cells+2];
  int g[cells+2];
  int b[cells+2];

  for (int i = 1; i <= cells; i++) {
    r[i] = rand() & 0xFFFF;
    g[i] = rand() & 0xFFFF;
    b[i] = rand() & 0xFFFF;
  }

  while (1) {
    int c = 1;
    for (int i = 0; i < geometry.size(); i++) {
      for (int lamp = 0; lamp < geometry[i]; lamp++) {
	l->Set(i, lamp, Color(r[c]>>8, g[cells - 1 - c]>>8, b[c]>>8));
        c++;
      }
    }
    l->Show();
    Update(r, cells);
    Update(g, cells);
    Update(b, cells);

    struct timeval now = Time();

    z += 0.2 * 30 * (now - t);
//    fprintf(stderr, " z = %f     ", z);
    t = now;
//    l->Set(2,(frame / 200) % 100 ,Color(0,0,0));
    fprintf(stderr, "\rFrame = %d ", frame++);
  }
}
