#ifndef LIGHTBUFFER_H
#define LIGHTBUFFER_H

#include <vector>

struct Color {
  Color(unsigned char r, unsigned char g, unsigned char b) {
    color[0] = r;
    color[1] = g;
    color[2] = b;
  }
  Color() { clear(); }
  void clear() {
    color[0] = 0;
    color[1] = 0;
    color[2] = 0;
  }
  unsigned char color[3];
};

class LightBuffer {
public:
  virtual ~LightBuffer() {}
  virtual int Set(int strip, int light, Color c) = 0;
  virtual void GetGeometry(std::vector<int>* row_lengths) = 0;
  virtual void Show() = 0;
  virtual void Sync() = 0;
};

LightBuffer* GetLightBuffer();
LightBuffer* GetLightBufferStdout();

#endif
