#include <stdio.h>
#include <stdlib.h>
#include "lightbuffer.h"
#include "math.h"
#include "timing.h"

int main() {
  LightBuffer *lb = GetLightBuffer();
  struct timeval start = Time();
  int frame = 0;
  while (1) {
    switch (getchar()) {
      case EOF: exit(0);
      default:
	fprintf(stderr, "Whut kind of file is this???\n");
	exit(1);
      case 0xEE:
	// Frame
	for (int s = 0; ; s++) {
	  int lights = getchar();
	  if (lights == EOF) {
	    fprintf(stderr, "End of file!\n");
	    exit(1);
	  }
	  lights <<= 8;
	  lights |= (unsigned char)getchar();
	  if (lights == 0) break;
	  for (int l = 0; l < lights; l++) {
	    int r = getchar();
	    if (r == EOF) {
	      fprintf(stderr, "End of file!\n");
	      exit(1);
	    }
	    int g = getchar();
	    int b = getchar();
	    lb->Set(s, l, Color(r, g, b));
	  }
	}
	lb->Show();
	frame++;
	Sleep(frame * 1.0001/24 - (Time() - start));
    }
  }
}
