#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

#include "matrix.h"
#include "random.h"
#include "images.h"
#include "thread_helper.h"

int strings;
int lights;
int num_images;

Matrix<float> read_images(int strings, int lights) {
  Matrix <float> tmp;
  for (int s = 0; s < strings; s++) {
    for (int l = 0; l < lights; l++) {
      char filename[512];
      sprintf(filename,"light-matrices/%02d-%02d.matrix", s, l);
      Matrix<float> lm = read_matrix(filename);
      if (tmp.columns() == 0) {
	tmp = Matrix<float>(lights * strings, lm.columns() * lm.rows());
      }
      for (int y = 0; y < lm.rows(); y++) {
	for (int x = 0; x < lm.columns(); x++) {
	  tmp.set(s * lights + l, y * lm.columns() + x, lm.get(x, y));
	}
      }
    }
  }
  return tmp;
}

int main(int argc, char **argv) {
  strings = atoi(argv[1]);
  lights = atoi(argv[2]);
  Matrix<float> tmp = read_images(strings, lights);
  fprintf(stderr,"Solving...\n");
  save_matrix(invert_nnls(tmp), stdout);
}
