#include <stdio.h>
#include "lights.h"
#include "math.h"

int main(int argc, char **argv) {
  int strings = atoi(argv[1]);
  int lights = atoi(argv[2]);
  TeensyLightWallRelay relay("/dev/ttyACM0", strings);
  vector<LampColor> colors(strings);
  vector<LampColor> black(strings);
  relay.Init();
  sleep(5);
  for (int s = 0; s < strings; s++) {
    colors[s].intensity = 0x00;
    colors[s].color[0] = 0x00;
    colors[s].color[1] = 0x00;
    colors[s].color[2] = 0x00;
  }
  for (int s = 0; s < strings; s++) {
    for (int l = 0; l < lights; l++) {
      fprintf(stderr, "String = %d light = %d\n", s, l);
      relay.SetPixels(63, black);
      for (int c = 0; c <= 7; c++) {
	colors = black;
	colors[s].intensity = 0xCC;
	colors[s].color[0] = c & 1 ? 0xFF : 0;
	colors[s].color[1] = c & 2 ? 0xFF : 0;
	colors[s].color[2] = c & 4 ? 0xFF : 0;
	relay.SetPixels(l, colors);

	struct timeval timeout;
	timeout.tv_sec = 0;
	timeout.tv_usec = 25000;
	select(0, NULL, NULL, NULL, &timeout);
      }
    }
    relay.SetPixels(63, black);
  }
}
