#ifndef CHAOSDISPLAY_SYNC_H
#define CHAOSDISPLAY_SYNC_H
#include <pthread.h>

template<class T>
class Sync {
public:
  Sync() {
    pthread_mutex_init(&lock_, NULL);
  }

  void Set(T t) {
    pthread_mutex_lock(&lock_);
    t_ = t;
    pthread_mutex_unlock(&lock_);
  }
  T Get() {
    pthread_mutex_lock(&lock_);
    T t = t_;
    pthread_mutex_unlock(&lock_);
    return t;
  }
 private:
  T t_;
  pthread_mutex_t lock_;
};

struct TimeSync {
  struct timeval t;
  double media_time;
};

#endif
