#include <stdio.h>
#include "lightbuffer.h"
#include "math.h"
#include "timing.h"

int main(int argc, char **argv) {
  LightBuffer* l = GetLightBuffer();
  std::vector<int> geometry;
  l->GetGeometry(&geometry);

  double z = 0.0;
  int frame = 0;
  struct timeval t = Time();
  for (int i = 0; i < geometry.size(); i++) {
    for (int lamp = 0; lamp < geometry[i]; lamp++) {
      l->Set(i, lamp, Color(0,0,0));
    }
  }
  l->Show();
  l->Show();
  l->Show();
  while (1) {
    for (int i = 0; i < geometry.size(); i++) {
      for (int lamp = 0; lamp < geometry[i]; lamp++) {
	float Z = z + sin(i + z);
	l->Set(i, lamp, Color(128 + 127 * sin(Z + lamp / 4.0),
			      128 + 127 * sin(Z * 0.77 + lamp / 4.0),
			      128 + 127 * sin(Z * 0.55 + lamp / 4.0)));
      }
    }
    l->Show();

    struct timeval now = Time();

    z += 0.2 * 30 * (now - t);
//    fprintf(stderr, " z = %f     ", z);
    t = now;
//    l->Set(2,(frame / 200) % 100 ,Color(0,0,0));
    fprintf(stderr, "\rFrame = %d ", frame++);
  }
}
