#include <stdio.h>
#include "lightbuffer.h"
#include "math.h"
#include "timing.h"

int main(int argc, char **argv) {
  LightBuffer* l = GetLightBuffer();
  std::vector<int> geometry;
  l->GetGeometry(&geometry);

  int frame = 0;
  struct timeval start = Time();
  while (1) {
    struct timeval now = Time();
    for (int i = 0; i < geometry.size(); i++) {
      for (int lamp = 0; lamp < geometry[i]; lamp++) {
	int set1 = (lamp + frame * (argc - 1)) / 50;
	int set2 = set1 + (set1 / 6);
	int set = (lamp & 1) ? set1 : set2;
	int c[] = { 0x100, 0x010, 0x001, 0x110, 0x011, 0x101 };
        int n = i == (((int)((now - start) * 1.5) ) % geometry.size()) ? 0xF0 : 0;
	l->Set(i, lamp, Color(((c[set % 6] >> 8) & 0x1)* n,
			      ((c[set % 6] >> 4) & 0x1)* n,
			      ((c[set % 6] >> 0) & 0x1)* n));
      }
    }
    l->Show();

    fprintf(stderr, "\rFrame = %d ", frame++);
  }
}
