#include <stdio.h>
#include <stdlib.h>

#include "lightbuffer.h"
#include "math.h"
#include "timing.h"

int main(int argc, char **argv) {
  LightBuffer* l = GetLightBuffer();
  std::vector<int> geometry;
  l->GetGeometry(&geometry);
  l->Show();
  l->Show();
  l->Show();
  int frame = 0;
  struct timeval start = Time();
  while (1) {
    frame++;
    struct timeval now = Time();
    for (int arg = 1; arg < argc; arg++) {
      int i = atoi(argv[arg]);
      for (int lamp = 0; lamp < geometry[i]; lamp++) {
	int set1 = lamp / 50;
	int set2 = set1 + (set1 / 6);
	int set = (lamp & 1) ? set1 : set2;
	if (lamp >= geometry[i]-3) set = lamp + frame;
	int c[] = { 0x100, 0x010, 0x001, 0x110, 0x011, 0x101 };
        int n = ((lamp+47) % 50) < 40 ? 0xAA : (int)(sin((7+i*2) * (now - start)) * 100 + 100.4);
	l->Set(i, lamp, Color(((c[set % 6] >> 8) & 0x1)* n,
			      ((c[set % 6] >> 4) & 0x1)* n,
			      ((c[set % 6] >> 0) & 0x1)* n));
      }
    }
    l->Show();
  }
}
